//
//  AKQuartzPhotoMachine.m
//  ScreenshotDemo
//
//  Created by Adrian on 1/27/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "AKQuartzPhotoMachine.h"

// Taken from http://www.cocoadev.com/index.pl?NSRectToCGRect
static inline CGRect NSRectToCGRect(NSRect nsRect)
{
    CGRect cgRect;

    cgRect.origin.x = nsRect.origin.x;
    cgRect.origin.y = nsRect.origin.y;
    cgRect.size.width = nsRect.size.width;
    cgRect.size.height = nsRect.size.height;

    return cgRect;
}

@implementation AKQuartzPhotoMachine

- (void) takeScreenshot
{
    NSRect rect = [[[NSScreen screens] objectAtIndex:0] frame];
    CGRect srcRect = NSRectToCGRect(rect);
    screenshot = [self imageFromCGImageRef:grabViaOpenGL(kCGDirectMainDisplay, srcRect)];
    [[NSNotificationCenter defaultCenter] postNotificationName:AKPhotoHasBeenTaken object:nil];
}

// Taken from http://developer.apple.com/documentation/Cocoa/Conceptual/CocoaDrawingGuide/Images/chapter_7_section_6.html
- (NSImage*) imageFromCGImageRef:(CGImageRef)img
{
    NSRect imageRect = NSMakeRect(0.0, 0.0, 0.0, 0.0);
    CGContextRef imageContext = nil;
    NSImage* newImage = nil;

    // Get the image dimensions.
    imageRect.size.height = CGImageGetHeight(img);
    imageRect.size.width = CGImageGetWidth(img);

    // Create a new image to receive the Quartz image data.
    newImage = [[NSImage alloc] initWithSize:imageRect.size]; 
    [newImage lockFocus];

    // Get the Quartz context and draw.
    imageContext = (CGContextRef)[[NSGraphicsContext currentContext]
                                         graphicsPort];

    CGContextDrawImage(imageContext, *(CGRect*)&imageRect, img);
    [newImage unlockFocus];
    return newImage;
}

@end
