//
//  AKQuickDrawPhotoMachine.m
//  ScreenshotDemo
//
//  Created by Adrian on 1/27/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "AKQuickDrawPhotoMachine.h"

// Taken from http://www.sticksoftware.com/developer/samplecode.html
Rect SSQDRectFromNSRect(NSRect cocoaRect, NSRect primaryScreenFrame)
{
	Rect rect;
	
	// Flip the "y" coordinants for QuickDraw
	cocoaRect.origin.y = primaryScreenFrame.size.height - cocoaRect.origin.y - cocoaRect.size.height;
	
	SetRect(&rect, NSMinX(cocoaRect), NSMinY(cocoaRect), NSMaxX(cocoaRect), NSMaxY(cocoaRect));
	
	return rect;
}

@implementation AKQuickDrawPhotoMachine

// Taken from http://www.sticksoftware.com/developer/samplecode.html
// Deprecated from Tiger, since it uses QuickDraw functions...
- (void)takeScreenshot
{
    NSScreen *primaryScreen = [[NSScreen screens] objectAtIndex:0];
    NSRect primaryScreenFrame = [primaryScreen frame];
    NSRect cocoaRect = [primaryScreen frame];
    
    // Convert NSRect to Rect
    Rect qdRect = SSQDRectFromNSRect(cocoaRect, primaryScreenFrame);
    
    // It seems the PixMap of the main device is used for all monitors
    GDHandle device = GetMainDevice();
    
    // Capture the screen into the PicHandle.  We have to loop through all our monitors because of a bug in CopyBits().  BCH 8/6/05
    PicHandle picHandle = OpenPicture(&qdRect);
    
    {
        NSArray *screens = [NSScreen screens];
        int screenCount = [screens count];
        int screenIndex;
        
        for (screenIndex = 0; screenIndex < screenCount; ++screenIndex)
        {
            NSScreen *screen = [screens objectAtIndex:screenIndex];
            NSRect screenFrame = [screen frame];
            NSRect intersectedScreenFrame = NSIntersectionRect(screenFrame, cocoaRect);
            
            if (!NSIsEmptyRect(intersectedScreenFrame))
            {
                qdRect = SSQDRectFromNSRect(intersectedScreenFrame, primaryScreenFrame);
                
                CopyBits((BitMap *)*(**device).gdPMap, (BitMap *)*(**device).gdPMap, &qdRect, &qdRect, srcCopy, 0l);
            }
        }
    }
    
    ClosePicture();

    // Convert the PicHandle into an NSImage
    HLock((Handle)picHandle);
    screenshot = [[NSImage alloc] initWithData:[NSData dataWithBytes:(*picHandle) length:GetHandleSize((Handle)picHandle)]];
    HUnlock((Handle)picHandle);
    
    // Release the PicHandle now that we're done with it
    KillPicture(picHandle);

    // Notify that we're ready to show the picture
    [[NSNotificationCenter defaultCenter] postNotificationName:AKPhotoHasBeenTaken object:nil];
}

@end
